#!/usr/bin/perl

for ($look = 0; $look < 2; $look++) {

  $stream = '';
  $slot = 1000;

  open FILE, "$ARGV[0]";

  while ('true') {
    read(FILE, $data, 1) or last;

    $v = unpack('C', $data);
    if ($v > 127.5 + 32) {$s = 0;};
    if ($v < 127.5 - 32) {$s = 1;};

    $change = 0;
    if ($l == $s) {
      # no transition
    } else {
      $change = 1;
      $tt = $time;
      $i = $tt - $ltt;
      $i = $i * 1200;
      #print "Interval: $i\n";
      $bits = int($i + 0.5);
      $stream .= "$l" x $bits;
      $ltt = $tt;
      $l = $s;
    };

    $time += 1/48000;

    next unless $change;

    $n = 32;

    $key = '01111100110100100001010111011000';
    #print "fuck, decode = $decode\n";
    if ($decode == 0 and 0 <= ($o = index($stream, $key))) {
      $o += length($key);
      $cut = substr($stream, 0, $o);
      print "Skipping: $cut\n";
      $stream = substr($stream, $o);
      print "Start of data block.\n";
      $decode = 1;
      $slot = 0;
    } elsif ($decode and length($stream) >= $n + 32) {

      $chop = substr($stream, 0, $n);
      $stream = substr($stream, $n);

      #$chop = reverse $chop;

      $bits = '';
      for ($i = 0; $i < 32; $i++) {
        $byte = int($i / 8);
        $bit = $i % 8;
        vec($bits, 8 * $byte + 7 - $bit, 1) = substr($chop, $i, 1);
      };
      $hex = uc unpack('H*', $bits);

      #substr($chop, 24, 0) = " ";
      #substr($chop, 16, 0) = " ";
      #substr($chop, 8, 0) = " ";

      @chars = split //, $bits;

      for ($i = 0; $i < 4; $i++) {
        $c = $chars[$i];
        $c = '.' if $c lt ' ';
        $c = '.' if $c gt '~';
        $chars[$i] = $c;
      };

#          01111100110100100001010111011000
#Slot 1000: 00000110010110111101010001001111 -- 065BD44F
#Slot 1001: 00001010111011000111110011010001 -- 0AEC7CD1
#Slot 1002: 00001010111011000111110011010001 -- 0AEC7CD1


      if ($hex eq '7CD215D8') {
        $slot = -1;
      };

      if ($hex eq 'FFFF0000') {
        $slot = 15;
        $decode = 0;
      };

      #$slot = substr('00' . $slot, -2);

      $" = '';
      if ($look) {
        #print "Slot $slot: $chop -- $hex - @chars - $seen{$chop}\n";
      } else {
        $seen{$chop}++;
        #print "Slot $slot: $chop -- $hex - @chars - Seen $seen{$chop} so far...\n";
      };
      print "Slot $slot: $chop -- $hex\n";

      #if ($hex eq '7A89C197') {
      #  #print "empty slot, ignoring...\n";
      #} els
      if ($slot >= 0 and $slot < 16) {

        @bit = split //, $chop;

        if ($bit[0] eq '0' || $hex eq '7A89C197' || $decode == 0) {
          # End of message...

          if ($pd ne '') {
            #print "Data from previous packet: address=$address, function=$function\n";
            #print "$pd\n";

            print "\e[1;31mAddress $address, function $function\e[0m\n";

            #if ($function < 2) {
              $message = '';
              #print "If it's a number: '";
              for ($i = 0; $i < length($pd); $i += 4) {
                $c = substr($pd, $i, 4);
                $d = '0';
                for ($j = 0; $j < 4; $j++) {
                  vec($d, $j, 1) = substr($c, $j, 1);
                };
                if ($d gt '9') {
                  $d = unpack('C', $d) - 48;
                  if ($d == 10) {$d = '?';};
                  if ($d == 11) {$d = 'U';};
                  if ($d == 12) {$d = ' ';};
                  if ($d == 13) {$d = '-';};
                  if ($d == 14) {$d = ')';};
                  if ($d == 15) {$d = '(';};
                };
                $message .= $d;
              };
              if (!exists $seen{$message}) {
                $seen{$message}++;
                print "Number: '\e[1;32m$message\e[0m'\n";
                #print "bits: '\e[1;34m$pd\e[0m'\n";
              } else {
                #print "Number: $message\n";
              };
            #} else {
              for ($o = 0; $o < 7; $o++) {
                $message = '';
                for ($i = 0; $i < length($pd) - 6 - $o; $i += 7) {
                  $c = substr($pd, $i + $o, 7);
                  $d = '';
                  for ($j = 0; $j < 7; $j++) {
                    vec($d, $j, 1) = substr($c, $j, 1);
                  };
                  if ($d lt ' ' or $d gt '~') {
                    $d = '[' . unpack('C', $d) . ']';
                  };
                  $message .= $d;
                };
                if ($o == 0 and !exists $seen{$message}) {
                  $seen{$message}++;
                  print "Text: '\e[1;32m$message\e[0m'\n";
                  #print "bits: '\e[1;34m$pd\e[0m'\n";
                } elsif (!exists $seen{$message}) {
                  #$seen{$message}++;
                  #print "Offset $o: $message\n";
                };
              };
            #};

          };

        };

        if ($bit[0] eq '0') {
          # New address...

          $address = 0;
          for ($i = 0; $i < 18; $i++) {
            $address <<= 1;
            $address |= $bit[$i + 1];
          };
          $address <<= 3;
          $address |= ($slot >> 1) & 7;

          $function = 0;
          for ($i = 0; $i < 2; $i++) {
            $function <<= 1;
            $function |= $bit[$i + 19];
          };
          $binary = substr($chop, 1, 18);
          #print "\e[1;31maddress = $address ($binary), function = $function\e[0m\n";
          $pd = '';
        } else {
          #print "This is a data field...\n";
          # It's data...
          for ($i = 0; $i < 20; $i++) {
            $pd .= $bit[$i + 1];
          };
        };

      };

      $slot++;

    };



  };

  close FILE;

  print "Remaining stream: $stream\n";

  exit;

  @order = sort {$seen{$a} <=> $seen{$b}} keys %seen;

  for ($i = 0; $i < @order; $i++) {
    print "$seen{$order[$i]}: $order[$i]\n";
  };

  $count = scalar(@order);
  print "There are $count codes total.\n";

};
