#!/usr/bin/perl
use Time::HiRes qw(gettimeofday);

$rate = 2400000 * 2;

while ('forever') {

  open FILE, "<", $ARGV[0];

  $start = gettimeofday();
  $actual_offset = 0;
  $desired_offset = 0;

  while ('whatever') {

    select undef, undef, undef, 0.1;
    $now = gettimeofday();
    $elapsed = $now - $start;

    $desired_offset = $rate * $elapsed;

    $bytes_to_read = $desired_offset - $actual_offset;

    last unless read(FILE, $data, $bytes_to_read);

    print $data;

    $actual_offset += $bytes_to_read;

  };

  close FILE;

};
